GenAuth DocsDocuments
Concepts
User Guide
Development Integration
AgentAuth
Metadata
Development Integration
Multi-tenant (beta)
Console Documentation
Multi-tenant Console
Tenant Console
Saas Application Demo
Concepts
User Guide
Development Integration
AgentAuth
Metadata
Development Integration
Multi-tenant (beta)
Console Documentation
Multi-tenant Console
Tenant Console
Saas Application Demo
Old version
Development Integration
  • API

  • SDK

    • Java

      • Installation and use
      • User authentication module

      • Management module

        • Manage users

        • Management Roles

        • Manage user groups

        • Manage custom fields

        • Manage Resources and Permissions

        • Manage data resources and permissions

          • Create permission space
          • Batch create permission spaces
          • Get permission space details
          • Batch get permission space details list
          • Paged get permission space list
          • Modify Permission Space
          • Delete Permission Space
          • Batch Delete Permission Space
          • Check whether the permission space Code or name is available
          • Paginated query of all roles in the permission space
          • Create data resources
          • Create string data resources
          • Create array data resources
          • Create tree data resources
          • Get data resource list
          • Get data resource information
          • Modify data resources
          • Delete data resources
          • Check data resource name or Code Is it available
          • Create data resource extension fields
          • Batch create data resource extension fields
          • Delete data resource extension fields
          • Modify data resource extension fields
          • Get data resource extension field list
          • Create data policy
          • Get data policy list
          • Get a list of simple data policy information
          • Get data policy information
          • Modify data policy
          • Delete data policy
          • Check whether the data policy name exists
          • Get all the information of the authorized subjects under the data policy
          • Authorize Data Policy
          • Revoke Data Policy
          • Get User Permission List
          • Judge user permissions
          • Judge external user permissions
          • Get user-specified resource permission list
          • Get a list of users authorized to use resources
          • Get a list of user-authorized resources
          • Get the structure list of external user authorization resources
          • Judge the user's permissions under the same level resources of the tree resource
        • Manage Applications

        • Manage Identity Sources

        • Manage security configuration

        • Manage message service

        • Manage Pipeline

        • Manage Webhook

        • Get audit log

        • Manage metering and billing

        • Events
    • Node.js

    • Python

  • Error Codes
  1. Development Integration
  2. /
  3. SDK
  4. /
  5. Java
  6. /
  7. Management module

  8. /
  9. Manage data resources and permissions

  10. /
  11. Create data resource extension fields

¶ Create data resource extension fields

Update time: 2025-07-23 07:34:21
Edit

Currently only supports tree type data resources

¶ Method Name

ManagementClient.createDnef

¶ Request Parameters

Type: CreateDenfDto

NameType
Is it required
Default Value
Description
Example Value
namespaceCodestringYesPermission space codeexamplePermissionNamespace
resourceCodestringYesData resource codetreeResourceCode
keystringYesExtension field Keystr
valueTypeValueTypeYesExtended field value typeSTRING (text), SELECT (single choice)
labelstringYesExtended field display namestr_label
configDnefConfigNoField configuration, single choice type fields must be passed

¶ Sample Code

package test.management.dataPermission.resource;

import cn.authing.sdk.java.dto.DnefConfig;
import cn.authing.sdk.java.dto.Dnef.ValueType;

import cn.authing.sdk.java.client.ManagementClient;
import cn.authing.sdk.java.dto.CreateDenfDto;
import cn.authing.sdk.java.dto.IsSuccessRespDto;
import cn.authing.sdk.java.model.ManagementClientOptions;
import cn.authing.sdk.java.util.JsonUtils;
import cn.hutool.core.collection.ListUtil;

public class CreateDnefTest {

    // Need to be replaced with your GenAuth Access Key ID
    private static final String ACCESS_KEY_ID = "AUTHING_ACCESS_KEY_ID";
    // Need to be replaced with your GenAuth Access Key Secret
    private static final String ACCESS_KEY_SECRET = "AUTHING_ACCESS_KEY_SECRET";

    public static void main(String[] args) throws Throwable {
        ManagementClientOptions clientOptions = new ManagementClientOptions();
        clientOptions.setAccessKeyId(ACCESS_KEY_ID);
        clientOptions.setAccessKeySecret(ACCESS_KEY_SECRET);
        // If you are a private deployment customer, you need to set the GenAuth service domain name
        // clientOptions.setHost("https://api.your-authing-service.com");
        ManagementClient client = new ManagementClient(clientOptions);
        CreateDenfDto createDenfDto = new CreateDenfDto();
        createDenfDto.setResourceCode("treeResourceCode");
        createDenfDto.setNamespaceCode("examplePermissionNamespace");
        createDenfDto.setKey("select");
        createDenfDto.setValueType(ValueType.SELECT);
        createDenfDto.setDescription("select");
        createDenfDto.setLabel("select");
        createDenfDto.setConfig(new DnefConfig(ListUtil.of(new DnefConfig.Option("str_value"))));
        IsSuccessRespDto res = client.createDnef(createDenfDto);
        System.out.println(JsonUtils.serialize(res));

        createDenfDto.setKey("str");
        createDenfDto.setValueType(ValueType.STRING);
        createDenfDto.setDescription("str");
        createDenfDto.setLabel("str");

        res = client.createDnef(createDenfDto);
        System.out.println(JsonUtils.serialize(res));
    }
}

¶ Request Response

Type: IsSuccessRespDto

NameTypeDescription
statusCodenumberBusiness status code. You can use this status code to determine whether the operation is successful. 200 means success.
messagestringDescription
apiCodenumberSegment error code, through which the specific error type can be obtained (not returned for successful requests). For a detailed list of error codes, see:API Code List (opens new window)
requestIdstringRequest ID. Returned when the request fails.
dataIsSuccessDtoWhether the operation is successful

¶ Data Structure

¶ IsSuccessDto

NameType
Is it required
Description
Example Value
successbooleanyesWhether the operation is successfultrue

¶ DnefConfig

NameType
Is it required
Description
Example Value
optionsOption[]YesSingle-select type field option list

¶ Option

NameType
Is it required
Description
Example Value
valuestringYesOption valueoption1
Previous article: Check data resource name or Code Is it available Next article: Batch create data resource extension fields
  • Method Name
  • Request Parameters
  • Sample Code
  • Request Response
  • Data Structure

User identity management

Integrated third-party login
Customized authentication process

Enterprise internal management

Single sign-on
Multi-factor authentication
Permission management

Developer

Development Documentation
GitHub (opens new window)

Company

official@genauth.ai
16th Floor, Building B, Beichen Century Center, Chaoyang District, Beijing (Total)
Room 406, 4th Floor, Block B, No. 200, Tianfu Fifth Street, High-tech Zone, Chengdu (Branch)

© Beijing Steamory Technology Co., Ltd.